program define _gstdof //gen standardized value per group
	version 6, missing
	syntax newvarname =/exp [if] [in] [, BY(varlist) Mean(real 0) Std(real 1)]

	tempvar touse m v
	quietly {
		gen byte `touse' = 1 `if' `in'
		sort `touse' `by'
		by `touse' `by' : gen double `m' = sum(`exp') / sum((`exp') < .) if `touse'==1
		by `touse' `by' : gen double `v' = sum(((`exp') - `m'[_N])^2) / (sum((`exp') < .) - 1) if `touse'==1 & sum((`exp') < .)
		by `touse' `by' : gen `typlist' `varlist' = `mean' + `std' * (`exp' - `m'[_N]) / sqrt(`v'[_N]) if `v'[_N]> 0.0000000001  //set non zero variance cases  
		//by `touse' `by' : gen `typlist' `varlist' = `mean' 											   if `v'[_N]<=0.0000000001  //set zero variance cases to mean unless all missing 

	}
end
